"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .project import Project, ProjectTypedDict
from enum import Enum
from latitudesh_python_sdk.types import BaseModel
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class CreateProjectProjectsType(str, Enum):
    PROJECTS = "projects"


class CreateProjectProvisioningType(str, Enum):
    r"""The provisioning type of the project. Default: on_demand"""

    RESERVED = "reserved"
    ON_DEMAND = "on_demand"


class CreateProjectProjectsEnvironment(str, Enum):
    DEVELOPMENT = "Development"
    STAGING = "Staging"
    PRODUCTION = "Production"


class CreateProjectProjectsAttributesTypedDict(TypedDict):
    name: str
    r"""The project name. Must be unique."""
    provisioning_type: CreateProjectProvisioningType
    r"""The provisioning type of the project. Default: on_demand"""
    description: NotRequired[str]
    r"""The project description."""
    environment: NotRequired[CreateProjectProjectsEnvironment]


class CreateProjectProjectsAttributes(BaseModel):
    name: str
    r"""The project name. Must be unique."""

    provisioning_type: CreateProjectProvisioningType
    r"""The provisioning type of the project. Default: on_demand"""

    description: Optional[str] = None
    r"""The project description."""

    environment: Optional[CreateProjectProjectsEnvironment] = None


class CreateProjectProjectsDataTypedDict(TypedDict):
    type: CreateProjectProjectsType
    attributes: NotRequired[CreateProjectProjectsAttributesTypedDict]


class CreateProjectProjectsData(BaseModel):
    type: CreateProjectProjectsType

    attributes: Optional[CreateProjectProjectsAttributes] = None


class CreateProjectProjectsRequestBodyTypedDict(TypedDict):
    data: NotRequired[CreateProjectProjectsDataTypedDict]


class CreateProjectProjectsRequestBody(BaseModel):
    data: Optional[CreateProjectProjectsData] = None


class CreateProjectResponseBodyTypedDict(TypedDict):
    r"""Success"""

    data: NotRequired[ProjectTypedDict]


class CreateProjectResponseBody(BaseModel):
    r"""Success"""

    data: Optional[Project] = None
